/*
  File: dragBoxAI.sqf
  Author: rbe
  
  Description:
  Makes the given unit drag a given box backwards to the given position.
  
  Parameter(s):
  _this select 0: unit (object)
  _this select 1: ammobox (object)
  _this select 2: destination/where to drag to (position)
  _this select 4: code to run after script finished, takes the draging unit as argument (string)
                  eg.: "_this doFollow player;", so the unit follows formation again
                  note: no sleep is allowed, since we compile/call this code! 
  
  Returns:
  nothing
*/
_unit = _this select 0;
_box = _this select 1;
_pos = _this select 2;
_code = "";
if ((count _this) > 3) then
{
   _code = (_this select 3);
};


// unfortunately we can't do a commandMove, if _unit is not player of his group,
// since he won't really move then?! WTF! :/ 
// too bad, so the unit will show as `ready` when in fact he's not :/
_unit doMove (position _box);


sleep 2;
waitUntil{unitReady _unit || !(alive _unit)};

_unit setUnitPos "MIDDLE";
sleep 1;

// we need to remember his primary weapon!
_u1stWeapon = primaryWeapon _unit;

[_box, _unit] execVM "dragBoxAction.sqf";
sleep 1;


/*
_unit doMove _pos;
sleep 2;
waitUntil{unitReady _unit || !(alive _unit)};
*/

// playAction-gestures:
// "StopRelaxed", "Stop", "GestureAgonyCargo", "GestureNod", "released", "agonyStart", "agonyStop", "grabCarry", "GestureLegPush", "walkb", "walkf", "crouch", "medicStart", "medicStop", "healedStart", "healedStop" 

_relDir = [_unit, _pos] call BIS_fnc_dirTo;
_unit setDir (_relDir - 180);

_i = 0;
while {(alive _unit) && ((_unit distance _pos) > 5)} do
{
   _unit playAction "walkb";
   sleep 1.5;
   _i = _i + 1;
   // adjust direction every few iterations
   if ((_i % 20) == 0) then
   {
      _relDir = [_unit, _pos] call BIS_fnc_dirTo;
      _unit setDir (_relDir - 180);
      _unit playAction "grabDrag";
      sleep 1.5;
   };
};

_unit playActionNow "medicStop";


[_unit, _unit, _box] execVM "dragBoxRelease.sqf";
if (_u1stWeapon != "") then
{
   _unit action ["TAKEWEAPON", _box, _u1stWeapon];
};
_unit setUnitPos "AUTO";


if (_code != "") then
{
   [_unit, _code] spawn {
      _unit = _this select 0;
      _code = compile (_this select 1);
      
      sleep 5;
      _unit call _code;
   };
};