/*
  File: dragBoxAI.sqf
  Author: rbe
  
  Description:
   dragBox logic (not used directly)
*/

_box = _this select 0;
_unit = _this select 1;

_behaviour = behaviour _unit;
_unit setVariable ["behaviour", _behaviour];
_unit setBehaviour "SAFE";


// ok, so we drop the primaryWeapon into the box then... 
// (action weapononback doesn't seem to work :/)
if ((primaryWeapon _unit) != "") then
{
   _unit action ["dropWeapon", _box, (primaryWeapon _unit)];
   _unit playAction "crouch";
};



_box attachTo [_unit,[0.3, 1.05, 1.25]];
[_box, -1 * (2 + random 8), -1 * (1 + random 4)] call BIS_fnc_setPitchBank;


sleep 0.2;
_box removeAction (_box getVariable "dragActionId");
_box setVariable ["dragActionId", -1];

sleep 0.1;
_playerActionId = _unit addAction [localize "STR_DragRelease", "dragBoxRelease.sqf"];
_unit setVariable ["dragObj", _box];
_unit setVariable ["dragActionId", _playerActionId];
                 
_uprightAnims = [
   "amovpercmrunsnonwnondf", "amovpercmrunsnonwnondfr", "amovpercmrunsnonwnondfl", "amovpercmrunsnonwnondb", "amovpercmrunsnonwnondbr", "amovpercmrunsnonwnondbl",
   "amovpercmwalksnonwnondf", "amovpercmwalksnonwnondfr", "amovpercmwalksnonwnondfl", "amovpercmwalksnonwnondb", "amovpercmwalksnonwnondbr", "amovpercmwalksnonwnondbl"
];
_forwardAnims = [
   "amovpknlmrunsnonwnondf", "amovpknlmrunsnonwnondfr", "amovpknlmrunsnonwnondfl",
   "amovpknlmwlksnonwnondf", "amovpknlmwlksnonwnondfr", "amovpknlmwlksnonwnondfl",
   "amovpknlmwlksraswrfldf", "amovpknlmwlksraswrfldfr", "amovpknlmwlksraswrfldfl",
   "amovpknlmrunsraswrfldf", "amovpknlmrunsraswrfldfr", "amovpknlmrunsraswrfldfl",
   "amovpknlmwlksraswpstdf", "amovpknlmwlksraswpstdfr", "amovpknlmwlksraswpstdfl"
];

// dragging loop
_particles = [];
while {(_unit getVariable "dragActionId") != -1} do
{   
   if (!(alive _unit) || !(alive _box)) exitWith 
   {
      _nul = [_unit, _unit, _box] execVM "dragBoxRelease.sqf";
   };
   if ((abs (speed _unit)) > 1.0) then
   {
      if ((count _particles) < 24) then
      {
         _particles = _particles + ([_box] call RUBE_PE_DragObj);   
      };
      // prevent upright walking
      if ((animationState _unit) in _uprightAnims) then
      {
         // AmovPknlMrunSnonWnonDf || AmovPercMstpSnonWnonDnon_AmovPknlMstpSnonWnonDnon
         //_unit switchMove "AmovPercMstpSnonWnonDnon_AmovPknlMstpSnonWnonDnon";
         _unit playAction "crouch";
         sleep 1;
      };
      
      // prevent forward movement
      // does not work well at all :/
      /*
      _unitAnim = toArray(animationState _unit);
      _n = (count _unitAnim) - 1;
      if (_n > 2) then
      {
         // d == 64, f == 66
         _l1 = _unitAnim select (_n - 2);
         _ln = _unitAnim select (_n - 1);
         if (_l1 != 64) then 
         {
            _l1 = _unitAnim select (_n - 1);
            _ln = _unitAnim select _n;
         };
         if (_l1 == 64 && _ln == 66) then
         {
            _unit playAction "walkb";
            sleep 0.75;
         };
      };
      */

      
      // limit speed
      if ((abs (speed _unit)) > 11) then
      {
         _vel = velocity _unit;
         _unit setVelocity [(_vel select 0) * 0.5,(_vel select 1) * 0.5,(_vel select 2)];
         _unit playAction "walkf";
         sleep 1.5;
      };
   } 
   else
   {
      {
         deleteVehicle _x;
      } forEach _particles;
      _particles = [];
   };
   sleep 0.05;
};

// delete particles
{
   deleteVehicle _x;
} forEach _particles;


