/*
  Author: 
   rbe
   
  Description:
   sets camofaces for a unit/units
  
  Parameters:
   _this select 0: unit or units (unit or array of units)
   _this select 1: use unique faces (boolean, optional: default = true)
*/
private ["_units", "_faces", "_uniqueFaces", "_notAvailable", "_faceId", "_camoId"];

_units = _this select 0;
_uniqueFaces = true;
_faces = [];
_notAvailable = ["FR_Cooper", "FR_Miles", "FR_OHara", "FR_Rodriguez", "FR_Sykes"];

if ((count _this) > 1) then
{
   _uniqueFaces = false;
};

if ((typeName _units) != "ARRAY") then
{
   _units = [(_this select 0)];
};

{
   if (!((typeOf _x) in _notAvailable)) then
   {
      _faceId = ceil (random 99);
      while {_faceId in _faces} do
      {
            _faceId = ceil (random 99);
      };
      if (_uniqueFaces) then
      {
            _faces = _faces + [_faceId];
      };
      
      if (_faceId < 10) then {
            _faceId = format["0%1", _faceId];
      };

      _camoId = ceil (random 5);

      _x setFace (format["Face%1_camo%2", _faceId, _camoId]);
   };
} forEach _units;
